scala.tools.nsc.backend.jvm.GenASM

# JCommonBuilder

###
Related Doc: package GenASM

#### abstract class JCommonBuilder extends JBuilder

functionality for building plain and mirror classes

Source
  GenASM.scala

Linear Supertypes
JBuilder, AnyRef, Any
Known Subclasses
JMirrorBuilder, JPlainBuilder
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. JCommonBuilder
2. JBuilder
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new JCommonBuilder(bytecodeWriter: GenASM.BytecodeWriter, needsOutfile: Boolean)

### Abstract Value Members

1. #### abstract def getCurrentCUnit(): Global.CompilationUnit

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from JCommonBuilder to any2stringadd[JCommonBuilder] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (JCommonBuilder, B)

   Implicit information
     This member is added by an implicit conversion from JCommonBuilder to ArrowAssoc[JCommonBuilder] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### val CLASS_CONSTRUCTOR_NAME: String

   Definition Classes
     JBuilder

7. #### val EMPTY_STRING_ARRAY: Array[String]

   Definition Classes
     JBuilder

8. #### val INSTANCE_CONSTRUCTOR_NAME: String

   Definition Classes
     JBuilder

9. #### val PublicStatic: Int

10. #### val PublicStaticFinal: Int

11. #### def addForwarders(isRemoteClass: Boolean, jclass: ClassVisitor, jclassName: String, moduleClass: Global.Symbol): Unit

    Add forwarders for all methods defined in `module` that don't conflict with methods in the companion class of `module`.

    Add forwarders for all methods defined in `module` that don't conflict with methods in the companion class of `module`. A conflict arises when a method with the same name is defined both in a class and its companion object: method signature is not taken into account.

12. #### def addInnerClasses(csym: Global.Symbol, jclass: ClassVisitor, isMirror: Boolean = false): Unit

    Definition Classes
      JBuilder

13. #### def addRemoteExceptionAnnot(isRemoteClass: Boolean, isJMethodPublic: Boolean, meth: Global.Symbol): Unit

    Adds a @remote annotation, actual use unknown.

    Adds a @remote annotation, actual use unknown.

    Invoked from genMethod() and addForwarder().

14. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

15. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

16. #### def createJAttribute(name: String, b: Array[Byte], offset: Int, len: Int): Attribute

    Definition Classes
      JBuilder

17. #### def createJClass(access: Int, name: String, signature: String, superName: String, interfaces: Array[String]): ClassWriter

    Returns a new ClassWriter for the class given by arguments.

    Returns a new ClassWriter for the class given by arguments.

    access

      the class's access flags. This parameter also indicates if the class is deprecated.

    name

      the internal name of the class.

    signature

      the signature of this class. May be `null` if the class is not a generic one, and does not extend or implement generic classes or interfaces.

    superName

      the internal of name of the super class. For interfaces, the super class is Object. May be `null`, but only for the Object class.

    interfaces

      the internal names of the class's interfaces (see `getInternalName`). May be `null`.

    Definition Classes
      JBuilder

18. #### def debugLevel: Int

19. #### def descriptor(s: Global.Symbol): String

    Definition Classes
      JBuilder

20. #### def descriptor(k: Global.icodes.TypeKind): String

    Definition Classes
      JBuilder

21. #### def descriptor(t: Global.Type): String

    Definition Classes
      JBuilder

22. #### def emitAnnotations(fw: FieldVisitor, annotations: List[Global.AnnotationInfo]): Unit

23. #### def emitAnnotations(mw: MethodVisitor, annotations: List[Global.AnnotationInfo]): Unit

24. #### def emitAnnotations(cw: ClassVisitor, annotations: List[Global.AnnotationInfo]): Unit

25. #### def emitArgument(av: AnnotationVisitor, name: String, arg: Global.ClassfileAnnotArg): Unit

26. #### def emitAssocs(av: AnnotationVisitor, assocs: List[(Global.Name, Global.ClassfileAnnotArg)]): Unit

27. #### val emitLines: Boolean

28. #### def emitParamAnnotations(jmethod: MethodVisitor, pannotss: List[List[Global.AnnotationInfo]]): Unit

29. #### val emitSource: Boolean

30. #### val emitVars: Boolean

31. #### def ensuring(cond: (JCommonBuilder) ⇒ Boolean, msg: ⇒ Any): JCommonBuilder

    Implicit information
      This member is added by an implicit conversion from JCommonBuilder to Ensuring[JCommonBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

32. #### def ensuring(cond: (JCommonBuilder) ⇒ Boolean): JCommonBuilder

    Implicit information
      This member is added by an implicit conversion from JCommonBuilder to Ensuring[JCommonBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

33. #### def ensuring(cond: Boolean, msg: ⇒ Any): JCommonBuilder

    Implicit information
      This member is added by an implicit conversion from JCommonBuilder to Ensuring[JCommonBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

34. #### def ensuring(cond: Boolean): JCommonBuilder

    Implicit information
      This member is added by an implicit conversion from JCommonBuilder to Ensuring[JCommonBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

35. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

36. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

37. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from JCommonBuilder to StringFormat[JCommonBuilder] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

38. #### def getAnnotPickle(jclassName: String, sym: Global.Symbol): Option[Global.AnnotationInfo]

    Returns a ScalaSignature annotation if it must be added to this class, none otherwise.

    Returns a ScalaSignature annotation if it must be added to this class, none otherwise. This annotation must be added to the class' annotations list when generating them.

    Depending on whether the returned option is defined, it adds to `jclass` one of: (a) the ScalaSig marker attribute (indicating that a scala-signature-annotation aka pickle is present in this class); or (b) the Scala marker attribute (indicating that a scala-signature-annotation aka pickle is to be found in another file).

    jclassName

      The class file that is being readied.

    sym

      The symbol for which the signature has been entered in the symData map. This is different than the symbol that is being generated in the case of a mirror class.

    returns

      An option that is:

      - defined and contains an AnnotationInfo of the ScalaSignature type, instantiated with the pickle signature for sym.
      - empty if the jclass/sym pair must not contain a pickle.

39. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

40. #### def getExceptions(excs: List[Global.AnnotationInfo]): List[String]

    Quoting from JVMS 4.7.5 The Exceptions Attribute "The Exceptions attribute indicates which checked exceptions a method may throw.

    Quoting from JVMS 4.7.5 The Exceptions Attribute "The Exceptions attribute indicates which checked exceptions a method may throw. There may be at most one Exceptions attribute in each method_info structure."

    The contents of that attribute are determined by the `String[] exceptions` argument to ASM's ClassVisitor.visitMethod() This method returns such list of internal names.

41. #### def getGenericSignature(sym: Global.Symbol, owner: Global.Symbol): String

42. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @HotSpotIntrinsicCandidate()

43. #### val innerClassBuffer: LinkedHashSet[Global.Symbol]

    Definition Classes
      JBuilder

44. #### def innerClassSymbolFor(s: Global.Symbol): Global.Symbol

    For given symbol return a symbol corresponding to a class that should be declared as inner class.

    For given symbol return a symbol corresponding to a class that should be declared as inner class.

    For example: class A { class B object C }

    then method will return: NoSymbol for A, the same symbol for A.B (corresponding to A$B class), and A$C$ symbol for A.C.

    Definition Classes
      JBuilder

45. #### def isDeprecated(sym: Global.Symbol): Boolean

    Definition Classes
      JBuilder

46. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

47. #### def javaArrayType(elem: Type): Type

    Definition Classes
      JBuilder

48. #### def javaName(sym: Global.Symbol): String

    Return the name of this symbol that can be used on the Java platform.

    Return the name of this symbol that can be used on the Java platform. It removes spaces from names.

    Special handling: scala.Nothing erases to scala.runtime.Nothing$ scala.Null erases to scala.runtime.Null$

    This is needed because they are not real classes, and they mean 'abrupt termination upon evaluation of that expression' or null respectively. This handling is done already in GenICode, but here we need to remove references from method signatures to these types, because such classes cannot exist in the classpath: the type checker will be very confused.

    Definition Classes
      JBuilder

49. #### def javaType(s: Global.Symbol): Type

    Definition Classes
      JBuilder

50. #### def javaType(t: Global.Type): Type

    Definition Classes
      JBuilder

51. #### def javaType(tk: Global.icodes.TypeKind): Type

    Definition Classes
      JBuilder

52. #### val mdesc_arglessvoid: String

    Definition Classes
      JBuilder

53. #### def mkArray(xs: Traversable[String]): Array[String]

    Specialized array conversion to prevent calling java.lang.reflect.Array.newInstance via TraversableOnce.toArray

    Specialized array conversion to prevent calling java.lang.reflect.Array.newInstance via TraversableOnce.toArray

    Definition Classes
      JBuilder

54. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

55. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

56. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @HotSpotIntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

57. #### def pickleMarkerForeign: Attribute

58. #### def pickleMarkerLocal: Attribute

59. #### val strMODULE_INSTANCE_FIELD: String

60. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

61. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

62. #### val versionPickle: PickleBuffer

63. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

64. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

65. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

66. #### def writeIfNotTooBig(label: String, jclassName: String, jclass: ClassWriter, sym: Global.Symbol): Unit

    Definition Classes
      JBuilder

67. #### def →[B](y: B): (JCommonBuilder, B)

    Implicit information
      This member is added by an implicit conversion from JCommonBuilder to ArrowAssoc[JCommonBuilder] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from JBuilder

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from JCommonBuilder to any2stringadd[JCommonBuilder]

### Inherited by implicit conversion StringFormat from JCommonBuilder to StringFormat[JCommonBuilder]

### Inherited by implicit conversion Ensuring from JCommonBuilder to Ensuring[JCommonBuilder]

### Inherited by implicit conversion ArrowAssoc from JCommonBuilder to ArrowAssoc[JCommonBuilder]

### Ungrouped